
#ifndef __TKS_MODULATOR_H__
#define __TKS_MODULATOR_H__

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~                                   ~
//~ TKSModulator                      ~
//~                                   ~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
class TKSModulator : public YAC_Object {
public:
    enum __types {
        MOD_SIN=0,
        MOD_TRI,
        MOD_SAW,
        MOD_RECT,
        MOD_NOISE,
        MOD_1BYX,
        MOD_ARRAY,
        MOD_SIN01,
        MOD_TRI01,
        MOD_SAW01,
        MOD_RECT01,
        MOD_NOISE01,
        MOD_1BYX01,

        MOD_NUMTYPES
    };

    enum __args {
        MOD_ARG_TYPE=0,
        MOD_ARG_AMP,
        MOD_ARG_OFF,
        MOD_ARG_SPEED,
        MOD_ARG_PULSEWIDTH,
        MOD_NUMARGS
    };

public:
    sF32 args[MOD_NUMARGS];
    sF32 arg_modamount[MOD_NUMARGS];
    sF32 arg_modamountmodamount[MOD_NUMARGS];
    TKSModulator *arg_mod[MOD_NUMARGS];
    TKSModulator *arg_modamountmod[MOD_NUMARGS];
	YAC_FloatArray *float_array;
    sF32 noiseval;

public:
    YAC_H(TKSModulator);
    TKSModulator();
    ~TKSModulator();

    void yacGetConstantStringList(YAC_String *_s);
    void initArgs(void);
    sF32 getValue(void);

#define YAC_CLASS TKSModulator
#define YAC_NUM_COMMANDS 18

#define YAC_CMD_0_NAME "operator"
#define YAC_CMD_0_RTTI 13
#define YAC_CMD_0_RET 4
#define YAC_CMD_0_SYM yacOperator
    void yacOperator(sSI, YAC_Object*, YAC_Value *);

#define YAC_CMD_1_NAME "setArg"
#define YAC_CMD_1_RTTI 9
#define YAC_CMD_1_SYM tksinter_setArg
    void tksinter_setArg(sS32, sF32);

#define YAC_CMD_2_NAME "setArgModulation"
#define YAC_CMD_2_RTTI 9
#define YAC_CMD_2_SYM tksinter_setArgModulation
    void tksinter_setArgModulation(sS32, sF32);

#define YAC_CMD_3_NAME "getArg"
#define YAC_CMD_3_RTTI 1
#define YAC_CMD_3_RET 2
#define YAC_CMD_3_SYM tksinter_getArg
    void tksinter_getArg(sS32, YAC_Value *_r);

#define YAC_CMD_4_NAME "setArgModulator"
#define YAC_CMD_4_RTTI 45
#define YAC_CMD_4_SYM tksinter_setArgModulator
    void tksinter_setArgModulator(sS32, YAC_Object *, sF32);

#define YAC_CMD_5_NAME "getArgModulator"
#define YAC_CMD_5_RTTI 1
#define YAC_CMD_5_RET 3
#define YAC_CMD_5_SYM tksinter_getArgModulator
    void tksinter_getArgModulator(sS32, YAC_Value *_r);

    //void tksinter_allocArgModulator(sS32, YAC_Object *_mod);
#define YAC_CMD_6_NAME "setArgModulationModulator"
#define YAC_CMD_6_RTTI 45
#define YAC_CMD_6_SYM tksinter_setArgModulationModulator
    void tksinter_setArgModulationModulator(sS32, YAC_Object *_modmod, sF32 _amount);

#define YAC_CMD_7_NAME "getArgModulationModulator"
#define YAC_CMD_7_RTTI 1
#define YAC_CMD_7_RET 3
#define YAC_CMD_7_SYM tksinter_getArgModulationModulator
    void tksinter_getArgModulationModulator(sS32, YAC_Value *_r);

#define YAC_CMD_8_NAME "setArray"
#define YAC_CMD_8_RTTI 3
#define YAC_CMD_8_SYM tksinter_setArray
    void tksinter_setArray(YAC_Object *_fa);

#define YAC_CMD_9_NAME "getArray"
#define YAC_CMD_9_RTTI  0
#define YAC_CMD_9_RET 3
#define YAC_CMD_9_SYM tksinter_getArray
    void tksinter_getArray(YAC_Value *_r);

#define YAC_CMD_10_NAME "init"
#define YAC_CMD_10_RTTI 41
#define YAC_CMD_10_SYM tksinter_init
    void tksinter_init(sS32 _type, sF32 _amp, sF32 _speed);

#define YAC_CMD_11_NAME "tick"
#define YAC_CMD_11_RTTI 2
#define YAC_CMD_11_SYM tksinter_tick
    void tksinter_tick(sF32);

#define YAC_CMD_12_NAME "getValue"
#define YAC_CMD_12_RTTI 0
#define YAC_CMD_12_RET 2
#define YAC_CMD_12_SYM tksinter_getValue
    void tksinter_getValue(YAC_Value *_r);

#define YAC_CMD_13_NAME "defaults"
#define YAC_CMD_13_RTTI 0
#define YAC_CMD_13_SYM initArgs

#define YAC_CMD_14_NAME "getArgModulationAmount"
#define YAC_CMD_14_RTTI 1
#define YAC_CMD_14_RET 2
#define YAC_CMD_14_SYM tksinter_getArgModulationAmount
	void tksinter_getArgModulationAmount(sS32 _arg, YAC_Value *_r);

#define YAC_CMD_15_NAME "setArgModulationAmount"
#define YAC_CMD_15_RTTI 9
#define YAC_CMD_15_SYM tksinter_setArgModulationAmount
	void tksinter_setArgModulationAmount(sS32 _arg, sF32 _amount);

#define YAC_CMD_16_NAME "getArgModulationModulationAmount"
#define YAC_CMD_16_RTTI 1
#define YAC_CMD_16_RET 2
#define YAC_CMD_16_SYM tksinter_getArgModulationModulationAmount
	void tksinter_getArgModulationModulationAmount(sS32 _arg, YAC_Value *_r);

#define YAC_CMD_17_NAME "setArgModulationModulationAmount"
#define YAC_CMD_17_RTTI 9
#define YAC_CMD_17_SYM tksinter_setArgModulationModulationAmount
	void tksinter_setArgModulationModulationAmount(sS32 _arg, sF32 _amount);



#include <yac_createcommands.h>
};



#endif
